/*This is the data file for the 'window looking out on Merunari Canyon. The
bounding box has been commented out because it traces much faster without it.
At 120x90, -a, it takes 20 seconds without the box, and 2:08 with it! The image
map of Merunari Canyon was created by Russell Leidich with his own personal 
landscape generator. The window frame was modeled in MORAY by Robert Mickelsen.*/



#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"
#include "moulding.inc"


camera {  //  Camera Camera01
  location  <7.348, 8.061, -23.696>
  direction <0.0,     0.0,  2.4880>
  sky       <0.0,     1.0,  0.0>
  up        <0.0,     1.0,  0.0>
  right     <1.3333,  0.0,  0.0>
  look_at   <0.000, 0.000, 0.000>
}

object {   // Light source Light001
  light_source {
    <-26.815, 16.639, -40.672>  //this light source gives better detail
    //<-5000, 5000, -5000>  //this is the group project default light source
    color  red 1.000 green 1.000 blue 1.000
  }
}

object {   // Light source Light002
  light_source {
    <-26.815, 16.639, -40.672>
    //<5000, 5000, -5000>
    color  red 1.000 green 1.000 blue 1.000
  }
}



#declare canyontex = texture {
  finish {
    ambient   1.0
    diffuse   0.0

  }
  pigment {
    image_map {
      gif "merunari.gif" map_type 0 interpolate 2 once
    }
  }
}

/*#declare wintex = texture {  //dummy texture for window frame
 pigment { color red  1.000 green  1.000 blue  1.000 }
 finish {
  ambient   0.10
  diffuse   0.50
  brilliance   1.00
  phong   0.60
  phong_size  20.00
 }
}*/

#declare windowbound = box {
   <-1.0, -1.0, -1.0>, <1.0, 1.0, 1.0>
   scale <4.112768, 4.285690, 1.069516>
   translate <-0.063019, 2.457735, 0>
}

#declare sill = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <4.000000, 1.000000, 0.200000>
}

#declare frame1 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.250000, 0.550000, 3.000000>
  translate <-3.569588, 0.444675, 3.202583>
}

#declare frame2 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.250000, 0.550000, 3.000000>
  translate <3.586321, 0.455282, 3.202583>
}

#declare frame3 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.250000, 0.550000, 3.825000>
  rotate <-0.000000, -90.000000, -0.000000>
  translate <0.011043, 0.455282, 6.455348>
}

#declare sillbase = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <3.900000, 0.500000, 0.750000>
  translate <0.000000, 0.346694, -0.962447>
}

#declare csgobj1 = union {
  object { sill }
  object { frame1 }
  object { frame2 }
  object { frame3 }
  object { sillbase }
}

#declare moulding1 = object {
  moulding
  scale <0.175000, 0.200000, 6.505000>
  rotate <-0.000000, -0.000000, -180.000000>
  translate <-3.671272, -0.292208, 0.201693>
}

#declare moulding2 = object {
  moulding
  scale <0.175000, 0.200000, 6.505000>
  rotate <-0.000000, -180.000000, -180.000000>
  translate <3.678644, -0.292208, 6.709047>
}

#declare moulding3 = object {
  moulding
  scale <0.175000, 0.200000, 7.700000>
  rotate <-0.000000, -90.000000, -180.000000>
  translate <-3.845547, -0.292208, 6.530681>
}

#declare moulding4 = object {
  moulding
  scale <0.500000, 0.500000, 7.800000>
  rotate <-0.000000, -90.000000, -180.000000>
  translate <-3.948652, -0.669691, -0.710094>
}

#declare winframe1 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.300000, 0.200000, 3.000000>
  translate <-3.020835, 0.628978, 3.231981>
}

#declare winframe2 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.300000, 0.200000, 3.000000>
  translate <3.038663, 0.628978, 3.231981>
}

#declare winframe3 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.300000, 0.200000, 3.000000>
  rotate <-0.000000, -90.000000, -0.000000>
  translate <0.041735, 0.628978, 5.865445>
}

#declare winframe4 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.300000, 0.200000, 3.000000>
  rotate <-0.000000, -90.000000, -0.000000>
  translate <0.005466, 0.628978, 0.482024>
}

/*the following declarations are for the cross moulding pieces in the window.
For a center cross configuration (+), use winglazing1 and winglazing4. For a
'tic-tac-toe' configuration (#), use winglazing2, 3, 5, and 6.*/

#declare winglazing1 = box {  //for center cross moulding
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.050000, 0.190000, 3.000000>
  translate <0.000000, 0.634033, 3.119166>
}
/*#declare winglazing2 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.050000, 0.190000, 3.000000>
  translate <1.800000, 0.634033, 3.119166>
}
#declare winglazing3 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.050000, 0.190000, 3.000000>
  translate <-1.800000, 0.634033, 3.119166>
}*/

#declare winglazing4 = box {  // for center cross moulding
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.050000, 0.190000, 3.000000>
  rotate <-0.000000, -90.000000, -0.000000>
  translate <0.000000, 0.634033, 3.119166>
}
/*#declare winglazing5 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.050000, 0.190000, 3.000000>
  rotate <-0.000000, -90.000000, -0.000000>
  translate <0.000000, 0.634033, 3.119166>
  translate <0, 0, 1.8>
}
#declare winglazing6 = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    Sandalwood
  }
  scale <0.050000, 0.190000, 3.000000>
  rotate <-0.000000, -90.000000, -0.000000>
  translate <0.000000, 0.634033, 3.119166>
  translate <0, 0, -1.8>
}*/

#declare pane = box {
  <-1, -1, -1>, <1, 1, 1>
  texture {
    canyontex
    scale <2.000000, 2.000000, 1.000000>
    rotate <90.000000, -0.000000, -0.000000>
    translate <-1.000000, -1.000000, -1.000000>
  }
  scale <3.000000, 0.050000, 3.000000>
  translate <0.036269, 0.698661, 2.991562>
}

union {   // window
  object { csgobj1 }
  object { moulding1 }
  object { moulding2 }
  object { moulding3 }
  object { moulding4 }
  object { winframe1 }
  object { winframe2 }
  object { winframe3 }
  object { winframe4 }
  object { winglazing1 }
  object { winglazing4 }
  //object { winglazing5 }
  //object { winglazing6 }
  object { pane }
  rotate <90, 0, 0>
  scale <1, -1, 1>
  //bounded_by { windowbound }  //traces faster without this.
  translate <0.000000, -2.472184, 0.376202>
}
